package cn.dankal.yunlaboratory.ui.activity;

import android.text.TextUtils;
import android.view.View;
import android.widget.EditText;
import android.widget.TextView;

import api.UserServiceFactory;
import butterknife.BindView;
import butterknife.OnClick;
import cn.dankal.basiclib.base.activity.BaseActivity;
import cn.dankal.basiclib.base.mvp.BasePresenter;
import cn.dankal.basiclib.model.BaseModel;
import cn.dankal.basiclib.model.SubmitResultBody;
import cn.dankal.basiclib.rx.MapFunc;
import cn.dankal.basiclib.rx.NormalSubscriber;
import cn.dankal.yunlaboratory.R;
import cn.dankal.yunlaboratory.ui.widget.MainButton;
import io.reactivex.disposables.Disposable;

public class UploadResultActivity extends BaseActivity {
    @BindView(R.id.tv_title)
    TextView tvTitle;
    @BindView(R.id.et_result)
    EditText etResult;
    @BindView(R.id.btn_upload)
    MainButton btnUpload;

    private SubmitResultBody body;

    @Override
    public BasePresenter createPresenter() {
        return null;
    }

    @Override
    protected int getLayoutId() {
        return R.layout.activity_upload_result;
    }

    @Override
    protected void initComponents() {
        tvTitle.setText("结果录入");
        body = (SubmitResultBody) getIntent().getSerializableExtra("data");
        btnUpload.setEnabled(true);
    }


    @OnClick({R.id.iv_onback, R.id.btn_upload})
    public void onViewClicked(View view) {
        switch (view.getId()) {
            case R.id.iv_onback:
                finish();
                break;
            case R.id.btn_upload:
                String report=etResult.getText().toString();

                if (!TextUtils.isEmpty(report)){
                    body.setContent(report);

                    UserServiceFactory.submitReport(body).map(new MapFunc<>()).subscribe(new NormalSubscriber<BaseModel<String>>() {
                        @Override
                        public void onSubscribe(Disposable d) {

                        }

                        @Override
                        public void onNext(BaseModel<String> stringBaseModel) {

                        }
                    });
                }else {
                    showToast("请填写样本检测报告");
                }
                break;
        }
    }
}
